# Chess with Teams

_Chess with Teams_ is a demonstration app for [Couchbase Lite](https://github.com/couchbase/couchbase-lite-ios) which attempts to make chess fun and social.  

![chess_with_friends_game_started.png](http://f.cl.ly/items/032s2f1j2z0E0O3I0G1M/Screen%20Shot%202013-04-22%20at%206.55.17%20PM.png)

It is a turn-based game, similar to _Chess with Friends_ except for one major twist: either side can form a **team**.  Players within the team take turns making the next move for the entire team.  

## Building and Installing

* Git clone this project
* Git clone [Couchbase Lite](https://github.com/couchbase/couchbase-lite-ios)
* Get submodules with `git submodule init && git submodule update`
* Build Couchbase Lite 
* Copy Couchbase Lite frameworks to /Frameworks directory
* Edit the URL in AppDelegate.m#serverUrl to point to your CouchDB or Sync Gateway
* Run the app on the simulator


# Chess with Teams - Technical Overview

Here is a 10,000 foot overview of what your architecture might look like:

![chess_with_teams_tech_architecture.png](http://tleyden-misc.s3.amazonaws.com/chess_with_teams_tech_architecture.png)

* The CouchBase Server would typically be behind your firewall, while the Sync Gateway would need to be exposed on a server with a public ip address.

* The Application Server is needed in this example in order to generate notifications when it's a players turn to move.  It watches the _changes feed on the Sync Gateway, and triggers push notifications in response. 

* The Application Server might possibly need to be exposed on the public internet and available for the app to make API calls to.  A possible scenario here might be for user account creation, in which case the Application Server would make a call to the Sync Gateway on the trusted "management port" and then propagate the response back to the ios app.  


